

load (file = "krysa3fda.RData")
xx <- seq(-15, 75, length.out = 100)

# nejprve zvolime "knots" pro splajny
(knots <- seq(-15, 75, by = 30))
rozsah <- range(knots)
# rad B-splajnu
norder <- 4

# odtud plyne velikost baze
nbasis <- length (knots) + norder - 2

# Vytvorime bazi splajnu
bbasis <- create.bspline.basis (rozsah, nbasis, norder, knots)

# kolik mame krivek?
n <- kolik <- 79


# Vytvorime "Lfd" objekty, dve moznosti:
# 1. int2Lfd -- just penalize some derivatives. 
curv.Lfd <- int2Lfd (2)

# 2. vec2Lfd -- a (constant) linear combination of derivatives; for technical
# reasons this also requires the range of the basis. 
harmLfd <- vec2Lfd (c(1, (2*pi/98)^2, 0), rangeval = rozsah)

#   # definujeme vyhlazovaci parametr lambda
lambda <- 1e2
# 
# # definujeme "fdPar" objekt 
curv.fdPar <- fdPar (bbasis, curv.Lfd, lambda)


w1 <- subset (df8fda, sound == "click" & treatment == "SS" & sample == 3)
iks <- unlist(w1$x[1])
krivky <- matrix(unlist(unlist(w1$Y)), nrow = length(iks))

# cyklus WHILE
lambdas <- 10
mean.gcv2 <- mean.gcv1 <- 10^8
# pokud je v dalsim kroku gcv vetsi, skonci se
while (mean.gcv1 >= mean.gcv2){
  mean.gcv1 <- mean.gcv2
  lambdas <- lambdas * 10^(1/2)
  # nastavime lambda
  curv.fdPari <- curv.fdPar
  curv.fdPari$lambda <- lambdas
  
  # hladime
  tempSmoothi <- smooth.basis(iks, krivky, curv.fdPari)
  
  # ulozime prumerne GCV
  mean.gcv2 <- mean(tempSmoothi$gcv)
}

# Vybereme nejlepsi a podle neho nadefinujeme hladkou bazi
lambdabest <- lambdas * 10^(-1/2)
curv.fdPar$lambda <- lambdabest
# hladime
tempSmooth <- smooth.basis(iks, krivky, curv.fdPar)

# A vykreslime vyslednou bazi
fdobjSmooth <- tempSmooth$fd
fdobjSmooth_der1 <- deriv.fd(tempSmooth$fd, 1) # 1. derivace
fdobjSmooth_der2 <- deriv.fd(tempSmooth$fd, 2) # 2. derivace
fdobjSmootheval <- eval.fd(fdobj = fdobjSmooth, evalarg = xx)
fdobjSmootheval_der1 <- eval.fd(fdobj = fdobjSmooth_der1, evalarg = xx)
fdobjSmootheval_der2 <- eval.fd(fdobj = fdobjSmooth_der2, evalarg = xx)
# vykresleni
x11()
plot(fdobjSmooth, main = "Puvodni data")
ylimity <- par("usr")[3:4]

####################################################################################################
# Analyza hlavnich komponent (PCA)
pcaobj <- pca.fd(fdobjSmooth, nharm=6, curv.fdPar)

pcaVarmx <- varmx.pca.fd(pcaobj)

# komp1=eval.fd(fdobj = pcaobj$harmonics[1], evalarg = xx)
# komp2=eval.fd(fdobj = pcaobj$harmonics[2], evalarg = xx)
# komp3=eval.fd(fdobj = pcaobj$harmonics[3], evalarg = xx)

# vykresleni hlavnich komponent
x11()
plot(pcaobj$harmonics[1:3]) # kresli slozky
 
#################################################################################

# rekonstrukce

scores = pcaobj$scores
PCs = pcaobj$harmonics

# Firstly, just the mean + PC1
mtempfd = mean(fdobjSmooth)

mm <- rep(1, kolik) %*% t(eval.fd(fdobj = mtempfd, evalarg = xx))
h1 <- scores[,1] %*% t(eval.fd(fdobj = PCs[1], evalarg = xx))
h2 <- scores[,2] %*% t(eval.fd(fdobj = PCs[2], evalarg = xx))
h3 <- scores[,3] %*% t(eval.fd(fdobj = PCs[3], evalarg = xx))

# Vykresleni
# zrekonstruovana
x11()
matplot(xx, t(mm + h1 + h2 + h3), type = "l", main = "Rekonstrukce", ylim = ylimity, 
        xlab = "time", ylab = "value")

# a jednotlive slozky (+ mean)
x11()
matplot(xx, t(mm + h1), type = "l", main = "1. komponenty", ylim = ylimity, 
        xlab = "time", ylab = "value")
x11()
matplot(xx, t(mm + h2), type = "l", main = "2. komponenty", ylim = ylimity, 
        xlab = "time", ylab = "value")
x11()
matplot(xx, t(mm + h3), type = "l", main = "3. komponenty", ylim = ylimity, 
        xlab = "time", ylab = "value")
