# Nacteni dat
# Knihovny a nastaveni

library (Hmisc)
library (gplots)
# library (ggthemes)
# library (gridExtra)
library (plyr)
library (fda)
library (foreach)
library (iterators)
source("npfda.R")
#graphics.off ()


###### Prevod na "fda" balik

load (file = "krysa3neskal.RData")
#levels (df8$treatment) <- c ("con", "SA")	#	Prejmenovani kategorie SS -> SA
df8$treatment <- factor (df8$treatment, levels = c("con", "SS"), order = TRUE)
df8$sample <- factor (df8$sample, levels = 1:8, ordered = TRUE)


df8fda <- df8
df8fda$y <- NULL
df8fda$xx <- NULL
df8fda$YY <- NULL
df8fda$YY1der <- NULL
df8fda$YY2der <- NULL
df8fda$spline <- NULL
xx <- seq(-15, 75, length.out = 100)


# nejprve zvolime "knots" pro splajny
(knots <- seq(-15, 75, by = 30))
rozsah <- range(knots)
# rad B-splajnu
norder <- 4

# odtud plyne velikost baze
nbasis <- length (knots) + norder - 2

# Vytvorime bazi splajnu
bbasis <- create.bspline.basis (rozsah, nbasis, norder, knots)

# kolik mame krivek?
n <- kolik <- 79


# Vytvorime "Lfd" objekty, dve moznosti:
# 1. int2Lfd -- just penalize some derivatives. 
curv.Lfd <- int2Lfd (2)

# 2. vec2Lfd -- a (constant) linear combination of derivatives; for technical
# reasons this also requires the range of the basis. 
harmLfd <- vec2Lfd (c(1, (2*pi/98)^2, 0), rangeval = rozsah)

#   # definujeme vyhlazovaci parametr lambda
 lambda <- 1e2
# 
# # definujeme "fdPar" objekt 
 curv.fdPar <- fdPar (bbasis, curv.Lfd, lambda)
# 
W <- data.frame(NULL)
 
kombinace <- ddply (df8fda, .(sound, treatment, sample), summarize, n = length(x)) 
       
vypocet <- foreach (case = iter (kombinace, by = "row"), .combine = "rbind") %do% {
  ID <- data.frame (id = 1:79)
  w1 <- subset (df8fda, sound == case$sound & treatment == case$treatment & sample == case$sample)
  w1 <- cbind (ID, w1)
  iks <- unlist(w1$x[1])
  krivky <- matrix(unlist(unlist(w1$Y)), nrow = length(iks))
  # ## Jak vybrat lambda?
  # cyklus WHILE
  lambdas <- 10
  mean.gcv2 <- mean.gcv1 <- 10^8
  # pokud je v dalsim kroku gcv vetsi, skonci se
  while (mean.gcv1 >= mean.gcv2){
    mean.gcv1 <- mean.gcv2
    lambdas <- lambdas * 10^(1/2)
    # nastavime lambda
    curv.fdPari <- curv.fdPar
    curv.fdPari$lambda <- lambdas
    
    # hladime
    tempSmoothi <- smooth.basis(iks, krivky, curv.fdPari)
    
    # ulozime prumerne GCV
    mean.gcv2 <- mean(tempSmoothi$gcv)
  }

  # Vybereme nejlepsi a podle neho nadefinujeme hladkou bazi
  lambdabest <- lambdas * 10^(-1/2)
  curv.fdPar$lambda <- lambdabest
  # hladime
  tempSmooth <- smooth.basis(iks, krivky, curv.fdPar)
  
  # A vykreslime vyslednou bazi
  fdobjSmooth <- tempSmooth$fd
  fdobjSmooth_der1 <- deriv.fd(tempSmooth$fd, 1) # 1. derivace
  fdobjSmooth_der2 <- deriv.fd(tempSmooth$fd, 2) # 2. derivace
  fdobjSmootheval <- eval.fd(fdobj = fdobjSmooth, evalarg = xx)
  fdobjSmootheval_der1 <- eval.fd(fdobj = fdobjSmooth_der1, evalarg = xx)
  fdobjSmootheval_der2 <- eval.fd(fdobj = fdobjSmooth_der2, evalarg = xx)
  # 2 moznosti pro vykresleni, obe stejne
  # x11()
  # par(mfrow=c(2,1))
  # matplot(xx, fdobjSmootheval, type = "l")
  # plot(fdobjSmooth)
  
  ####################################################################################################
  # Analyza hlavnich komponent (PCA)
  
  pcaobj <- pca.fd(fdobjSmooth, nharm=5, curv.fdPar)
  pcader1obj <- pca.fd(fdobjSmooth_der1, nharm=5, curv.fdPar)
  
  # pcaVarmx <- varmx.pca.fd(pcaobj)
  # 
  # komp1=eval.fd(fdobj = pcaobj$harmonics[1], evalarg = xx)
  # komp2=eval.fd(fdobj = pcaobj$harmonics[2], evalarg = xx)
  # komp3=eval.fd(fdobj = pcaobj$harmonics[3], evalarg = xx)
  #################################################################################
  
  w <- adply(w1, 1, function (r) {
    YY <- fdobjSmootheval[, r$id[[1]]]
    YY1der <- fdobjSmootheval_der1[, r$id[[1]]]
    YY2der <- fdobjSmootheval_der2[, r$id[[1]]]
    FDAobj <- fdobjSmooth
    
    data.frame(xx = I(list(xx)), YY = I(list(YY)), YY1der = I(list(YY1der)), YY2der = I(list(YY2der)), FDAobj = I(list(FDAobj)),
               PCAobj = I(list(pcaobj)), PCAder1obj = I(list(pcader1obj)))#, pcaVarmx = I(list(pcaVarmx)))
    # komp1 = I(list(komp1)), komp2 = I(list(komp2)), komp3 = I(list(komp3)))#, pcaVarmx = I(list(pcaVarmx)))
  })
  W <- rbind(W, w)
}  

df8fda <- W
df8 <- df8fda
save (file = "krysa3fda.RData",df8)

# plot harmonics
# op <- par(mfrow=c(2,2))
# plot.pca.fd(pcaobj, cex.main=0.9)
# plot.pca.fd(pcaVarmx, cex.main=0.9)
# par(op)
# plot(pcaobj$harmonics)
# plot(pcaVarmx$harmonics)
# 
# plot(pcaobj$harmonics[1:3]) # kresli slozky
# 
# plot(pcaobj$varprop,type='b')  # podil na vysvetleni
# #nebo
# plot(pcaobj,harm=1:3)

df8$treatment <- factor (df8$treatment, levels = c("con", "SS"), order = TRUE)
df8$sample <- factor (df8$sample, levels = 1:8, ordered = TRUE)

xx <- df8[1,]$xx[[1]]

id <- 0
w <- apply (df8, 1, function (r) {
  id <<- id + 1
  data.frame(rat=r$rat, sound=r$sound, treatment=r$treatment, id=id, sample=r$sample, xx=r$xx, YY=r$YY, YY1der=r$YY1der, YY2der=r$YY2der, 
             session=paste(r$treatment, r$sample, sep=" "), SC1 = r$PCAobj$scores[r$id,1], SC2 = r$PCAobj$scores[r$id, 2]) 
#             komp1 = r$komp1, komp2 = r$komp2, komp3 = r$komp3)
}) 
df10 <- do.call ("rbind", w)

df10$id <- factor (df10$id)
df10$session <- factor (df10$session, levels = c("con 1", "con 2", "con 3", "con 4", "con 5", "con 6", "SS 1", "SS 2", "SS 3", "SS 4", "SS 5", "SS 7", "SS 8"), ordered = TRUE)
df10$treatment <- factor (df10$treatment, levels = c("SS", "con"), ordered = TRUE)


ww <- apply (kombinace, 1, function (r) {
#  print(r["sound"][1])
  w1 <- subset (df8, sound == r["sound"][1] & treatment == r["treatment"][1] & sample == r["sample"][1] & id == 1)
  XM.eval <- eval.fd(mean(w1$FDAobj[[1]]), unlist(w1$xx))
  sig.eval <- eval.bifd(unlist(w1$xx), unlist(w1$xx), var.fd(w1$FDAobj[[1]]))
  horni <- XM.eval + sqrt(diag(sig.eval))
  dolni <- XM.eval - sqrt(diag(sig.eval))
  data.frame(sound=rep(r["sound"][1], 100), treatment=rep(r["treatment"][1], 100), sample=rep(r["sample"][1],100), xx=unlist(w1$xx), 
             session=paste(r["treatment"][1], r["sample"][1], sep=" "), XM = XM.eval, horni = horni, dolni = dolni)
#              SC1 = w1$PCAobj$scores[1,1], SC2 = w1$PCAobj$scores[1, 2])# komp1 = r$komp1, komp2 = r$komp2, komp3 = r$komp3)
}) 
df11 <- do.call ("rbind", ww)
#df11$id <- factor (df11$id)
df11$session <- factor (df11$session, levels = c("con 1", "con 2", "con 3", "con 4", "con 5", "con 6", "SS 1", "SS 2", "SS 3", "SS 4", "SS 5", "SS 7", "SS 8"), ordered = TRUE)
df11$treatment <- factor (df11$treatment, levels = c("SS", "con"), ordered = TRUE)


x11()
p0 <- ggplot (data = df10, aes (x = xx, y = YY, group = id))
p0 <- p0 + geom_line (colour = "#00BFC4") 
p0 <- p0 + facet_grid (sound ~ session)
p0 <- p0 + guides (alpha = FALSE, colour = FALSE) 
p0 <- p0 + labs (x = "sound intensity [dB SPL]", y = "EPI response splines") 
p0 <- p0 + scale_x_continuous(breaks = c(0, 30, 60))
p0 <- p0 + theme_bw()
p0 <- p0 + theme(axis.text.x = element_text(angle = 90, vjust = 0.5))
p0

dev.copy2pdf (file = "figs/all_curv.pdf", width = 9, height = 4)

x11()
p0 <- ggplot (data = df10, aes (x = xx, y = YY1der, group = id))
p0 <- p0 + geom_line (colour = "#F8766D") 
p0 <- p0 + facet_grid (sound ~ session)
p0 <- p0 + guides (alpha = FALSE, colour = FALSE) 
p0 <- p0 + labs (x = "sound intensity [dB SPL]", y = "First derivative of EPI response splines") 
p0 <- p0 + scale_x_continuous(breaks = c(0, 30, 60))
p0 <- p0 + scale_y_continuous(limits = c(-1.5, 2.5))
p0 <- p0 + theme_bw()
p0 <- p0 + theme(axis.text.x = element_text(angle = 90, vjust = 0.5))
p0

dev.copy2pdf (file = "figs/all_deriv.pdf", width = 9, height = 4)


# Fig. vsechny hlavni komponenty, aktualizace 17. 10. 2017

x11()
p0 <- ggplot (data = df10, aes (x = xx, y = PC1, group = id))
p0 <- p0 + geom_line (colour = "#00BFC4") 
p0 <- p0 + geom_line (aes(y = PC2), colour = "#F8766D") 
p0 <- p0 + geom_line (aes(y = PC3), colour = "green") 
p0 <- p0 + facet_grid (sound ~ session)
p0 <- p0 + guides (alpha = FALSE, colour = FALSE) 
p0 <- p0 + labs (x = "sound intensity [dB SPL]", y = "EPI response splines") 
p0 <- p0 + scale_x_continuous(breaks = c(0, 30, 60))
p0 <- p0 + theme_bw()
p0 <- p0 + theme(axis.text.x = element_text(angle = 90, vjust = 0.5))
p0

dev.copy2pdf (file = "figs/all_compon123.pdf", width = 9, height = 4)

# vsechny koeficienty u hlavnich komponent

x11()
p0 <- ggplot (data = df10, aes (x = SC1, y = SC2, group = id))
p0 <- p0 + geom_point (colour = "#00BFC4") 
p0 <- p0 + facet_grid (sound ~ session)
p0 <- p0 + guides (alpha = FALSE, colour = FALSE) 
p0 <- p0 + labs (x = "score 1", y = "score 2") 
#p0 <- p0 + scale_x_continuous(breaks = c(0, 30, 60))
p0 <- p0 + theme_bw()
p0 <- p0 + theme(axis.text.x = element_text(angle = 90, vjust = 0.5))
p0

dev.copy2pdf (file = "figs/all_components2.pdf", width = 9, height = 4)

# kresli prumerne krivky
x11()
p0 <- ggplot (data = df11, aes (x = xx, y = mean))
p0 <- p0 + geom_line (colour = "#00BFC4") 
p0 <- p0 + facet_grid (sound ~ session)
p0 <- p0 + guides (alpha = FALSE, colour = FALSE) 
p0 <- p0 + labs (x = "sound intensity [dB SPL]", y = "mean EPI response") 
#p0 <- p0 + scale_x_continuous(breaks = c(0, 30, 60))
p0 <- p0 + theme_bw()
p0 <- p0 + theme(axis.text.x = element_text(angle = 90, vjust = 0.5))
p0

dev.copy2pdf (file = "figs/all_means.pdf", width = 9, height = 4)


####################################################################################################################
# mean
XM <- mean(fdobjSmooth)
XM.eval <- eval.fd(XM, xx)

# Var
sig <- var.fd(fdobjSmooth)
sig.eval <- eval.bifd(xx, xx, sig)

horni <- XM.eval + sqrt(diag(sig.eval))
dolni <- XM.eval - sqrt(diag(sig.eval))
ylims <- range(c(horni, dolni))
plot(xx, XM.eval, ylim = ylims, type = "l")
lines(xx, dolni, col = "red")
lines(xx, horni, col = "red")

####
pcaobj <- pca.fd(fdobjSmooth, nharm=6, curv.fdPar)
pcaVarmx <- varmx.pca.fd(pcaobj)

# podily vysvetleni
cumsum(pcaobj$varprop)
d <- pcaobj$values

scores = pcaobj$scores
PCs = pcaobj$harmonics

SC1_inter <- quantile(scores[, 1], c(0.25, 0.75))
SC2_inter <- quantile(scores[, 2], c(0.25, 0.75))
SC3_inter <- quantile(scores[, 3], c(0.25, 0.75))

uloz <- rowSums(scores[, 1:3])

ind <- order(rowSums(scores[, 1:3]^2))
ind1 <- order(scores[,1]^2)
#indexy <- round(quantile(1:length(ind), c(0.1, 0.9)))

SC1_inter <- scores[ind[c(1,75)], 1:3]
SC4_inter <- scores[ind[30:33], 1:3]

#pomoci values (d)
plusminus <- 2*sqrt(d[1:3])

h1 <- SC1_inter %*% t(eval.fd(fdobj = PCs[1:3], evalarg = xx))
h4 <- SC4_inter %*% t(eval.fd(fdobj = PCs[1:3], evalarg = xx))

h <- plusminus %*% t(eval.fd(fdobj = PCs[1:3], evalarg = xx))

# Vykresleni
# zrekonstruovana
horni <- t(XM.eval) + h #[2, ] + h2[2, ] + h3[2, ]
dolni <- t(XM.eval) - h #[2, ] + h2[2, ] + h3[2, ]

dolni <- XM.eval + h1[1, ] + h2[1, ] + h3[1, ]
ylims <- range(c(horni, dolni))

x11()
matplot(xx, t(horni), type = "l")
plot(xx, XM.eval, ylim = ylims, type = "l")
lines(xx, dolni, col = "green")
lines(xx, horni, col = "red")
lines(xx, XM.eval, col = "green")
matplot(xx, t(dolni), type = "l", add = TRUE, col = "blue")

odh <- kde(scores[, 1:2], eval.points = scores[, 1:2])
x1 <- odh$eval.points[[1]][(which((odh$estimate < odh$cont["5%"]) & (odh$estimate > odh$cont["4%"]), arr.ind = T)[,1])]
x2 <- odh$eval.points[[2]][(which((odh$estimate < odh$cont["5%"]) & (odh$estimate > odh$cont["4%"]), arr.ind = T)[,2])]

x11()
plot(xx, t(mm + h1 + h2 + h3), type = "l", main = "Rekonstrukce", ylim = ylimity, 
        xlab = "time", ylab = "value")




  ##### 2. PCA and Smoothing
  
  # The PCs above are fairly rough, we can also add a smoothing penalty (see
  # the special topics slides). 
  
  pca.fdPar = fdPar(bbasis,curv.Lfd,10000*lambdabest)
  
  tempPCAsmooth = pca.fd(tempSmooth$fd,nharm=6,harmfdPar=pca.fdPar)
  
  # Let's plot the PCs
  
  plot(tempPCAsmooth$harmonics[1:3])
  
  # We can see that these are considerably smoother but still have pretty much
  # the same interpretation. 
  
  plot(tempPCAsmooth)
  
  ##### 3. PCA and Reconstructing Data
  
  # We can ask how well the PCs reconstruct the observed functions. We'll focus
  # on the first observation and reconstructing using PC score.
  
  # Let's extract the scores and PCs just to make the code easier to read
  
  scores = tempPCAsmooth$scores
  PCs = tempPCAsmooth$harmonics
  
  # Firstly, just the mean + PC1
  tempfd <- tempSmooth$fd
  mtempfd = mean(tempSmooth$fd)

  ex.temp.r1 = mtempfd + scores[1,1]*PCs[1]
  
  # and plot these
  
  plot(tempfd[1],ylim=c(-1,4))
  lines(mtempfd,col=2)
  lines(ex.temp.r1,col=3)
  
  # Try adding the second PC
  
  ex.temp.r2 = mtempfd + scores[1,1]*PCs[1] + scores[1,2]*PCs[2]
  lines(ex.temp.r2,col=4)
  
  # And the third
  
  ex.temp.r3 = ex.temp.r2  + scores[1,3]*PCs[3]
  lines(ex.temp.r3,col=6)
  
  ### THOUGHT EXERCISE: how would you use this to choose the level of smoothing
  ### in pca.fd by leave-one-curve-out cross validation? 
  